Prism.languages.graphql = {
  comment: /#.*/,
  description: {
    pattern: /(?:"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*")(?=\s*[a-z_])/i,
    greedy: !0,
    alias: "string",
    inside: {
      "language-markdown": {
        pattern: /(^"(?:"")?)(?!\1)[\s\S]+(?=\1$)/,
        lookbehind: !0,
        inside: Prism.languages.markdown
      }
    }
  },
  string: {
    pattern: /"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*"/,
    greedy: !0
  },
  number: /(?:\B-|\b)\d+(?:\.\d+)?(?:e[+-]?\d+)?\b/i,
  boolean: /\b(?:false|true)\b/,
  variable: /\$[a-z_]\w*/i,
  directive: {
    pattern: /@[a-z_]\w*/i,
    alias: "function"
  },
  "attr-name": {
    pattern: /\b[a-z_]\w*(?=\s*(?:\((?:[^()"]|"(?:\\.|[^\\"\r\n])*")*\))?:)/i,
    greedy: !0
  },
  "atom-input": {
    pattern: /\b[A-Z]\w*Input\b/,
    alias: "class-name"
  },
  scalar: /\b(?:Boolean|Float|ID|Int|String)\b/,
  constant: /\b[A-Z][A-Z_\d]*\b/,
  "class-name": {
    pattern: /(\b(?:enum|implements|interface|on|scalar|type|union)\s+|&\s*|:\s*|\[)[A-Z_]\w*/,
    lookbehind: !0
  },
  fragment: {
    pattern: /(\bfragment\s+|\.{3}\s*(?!on\b))[a-zA-Z_]\w*/,
    lookbehind: !0,
    alias: "function"
  },
  "definition-mutation": {
    pattern: /(\bmutation\s+)[a-zA-Z_]\w*/,
    lookbehind: !0,
    alias: "function"
  },
  "definition-query": {
    pattern: /(\bquery\s+)[a-zA-Z_]\w*/,
    lookbehind: !0,
    alias: "function"
  },
  keyword: /\b(?:directive|enum|extend|fragment|implements|input|interface|mutation|on|query|repeatable|scalar|schema|subscription|type|union)\b/,
  operator: /[!=|&]|\.{3}/,
  "property-query": /\w+(?=\s*\()/,
  object: /\w+(?=\s*\{)/,
  punctuation: /[!(){}\[\]:=,]/,
  property: /\w+/
};
Prism.hooks.add("after-tokenize", function(m) {
  if (m.language !== "graphql")
    return;
  var i = m.tokens.filter(function(t) {
    return typeof t != "string" && t.type !== "comment" && t.type !== "scalar";
  }), n = 0;
  function o(t) {
    return i[n + t];
  }
  function d(t, a) {
    a = a || 0;
    for (var e = 0; e < t.length; e++) {
      var r = o(e + a);
      if (!r || r.type !== t[e])
        return !1;
    }
    return !0;
  }
  function g(t, a) {
    for (var e = 1, r = n; r < i.length; r++) {
      var h = i[r], b = h.content;
      if (h.type === "punctuation" && typeof b == "string") {
        if (t.test(b))
          e++;
        else if (a.test(b) && (e--, e === 0))
          return r;
      }
    }
    return -1;
  }
  function u(t, a) {
    var e = t.alias;
    e ? Array.isArray(e) || (t.alias = e = [e]) : t.alias = e = [], e.push(a);
  }
  for (; n < i.length; ) {
    var y = i[n++];
    if (y.type === "keyword" && y.content === "mutation") {
      var s = [];
      if (d(["definition-mutation", "punctuation"]) && o(1).content === "(") {
        n += 2;
        var l = g(/^\($/, /^\)$/);
        if (l === -1)
          continue;
        for (; n < l; n++) {
          var p = o(0);
          p.type === "variable" && (u(p, "variable-input"), s.push(p.content));
        }
        n = l + 1;
      }
      if (d(["punctuation", "property-query"]) && o(0).content === "{" && (n++, u(o(0), "property-mutation"), s.length > 0)) {
        var v = g(/^\{$/, /^\}$/);
        if (v === -1)
          continue;
        for (var f = n; f < v; f++) {
          var c = i[f];
          c.type === "variable" && s.indexOf(c.content) >= 0 && u(c, "variable-input");
        }
      }
    }
  }
});
